<?php

class Czater extends Module
{
    private $_html = '';

    public function __construct() {
        $this->name = 'czater';
        $this->tab = 'Other';
        $this->version = '1.0.1';
        $this->author = 'Czater.pl';
        parent::__construct();
        $this->displayName = $this->l('Czater.pl');
        $this->description = $this->l('Live chat na Twoją stronę');
    }

    public function install() {
        if (!parent::install() ||
		!$this->registerHook('footer')  ||
		!Configuration::updateValue('czaterCode', '0')  ||
		!Configuration::updateValue('czaterAutoCompliteLogin', '0')  ||
		!Configuration::updateValue('czaterAutoCompliteEmail', '0'))
		return false;

	return true;
    }
	public function uninstall()
	{
		if (!parent::uninstall() ||
		!Configuration::deleteByName('czaterCode') ||
		!Configuration::deleteByName('czaterAutoCompliteLogin') ||
		!Configuration::deleteByName('czaterAutoCompliteEmail'))
		return false;

	return true;
	}
    public function getContent() {

        if (Tools::isSubmit('submit_text')) {

            Configuration::updateValue(
                    $this->name . '_czaterCode', Tools::getValue('czaterCode')
            );
            Configuration::updateValue(
                    $this->name . '_czaterAutoCompliteLogin', Tools::getValue('czaterAutoCompliteLogin')
            );
            Configuration::updateValue(
                    $this->name . '_czaterAutoCompliteEmail', Tools::getValue('czaterAutoCompliteEmail')
            );
        }

        $this->_generateForm();
        return $this->_html;
    }

    private function _generateForm() {

        $czaterCode = Configuration::get($this->name . '_czaterCode');
        $czaterAutoCompliteLogin = Configuration::get($this->name . '_czaterAutoCompliteLogin');
        $czaterAutoCompliteEmail = Configuration::get($this->name . '_czaterAutoCompliteEmail');

        $this->_html .= '<form action="' . $_SERVER['REQUEST_URI'] . '" method="post">';
        $this->_html .= '<h1>' . $this->l('Wstaw kod czatu pobrany ze strony:').' <a href=https://www.czater.pl/userPanel/codes>Czater.pl</a> </h1>';
        $this->_html .= '<label>' . $this->l('Kod Czatu : ') . '</label>';
        $this->_html .= '<div class="margin-form">';
        $this->_html .= '<textarea style="width:400px; height:200px;" name="czaterCode" >' . $czaterCode . '</textarea>';
        $this->_html .= '</div>';
        
        
        $this->_html .= '<label>' . $this->l('Automatycznie wypelniaj login : ') . '</label>';
        $this->_html .= '<div class="margin-form">';
        if($czaterAutoCompliteLogin == 1)
            $this->_html .= '<input type="checkbox" name="czaterAutoCompliteLogin" value="1" checked="checked">';
        else
            $this->_html .= '<input type="checkbox" name="czaterAutoCompliteLogin" value="1">';
        $this->_html .= '</div>';
        
        
        $this->_html .= '<label>' . $this->l('Automatycznie wypelniaj Email : ') . '</label>';
        $this->_html .= '<div class="margin-form">';
        if($czaterAutoCompliteEmail == 1)
            $this->_html .= '<input type="checkbox" name="czaterAutoCompliteEmail" value="1" checked="checked">';
        else
            $this->_html .= '<input type="checkbox" name="czaterAutoCompliteEmail" value="1">';
        $this->_html .= '</div>';
        
        
        $this->_html .= '<input type="submit" name="submit_text" ';
        $this->_html .= 'value="' . $this->l('Zapisz') . '" class="button" />';
        $this->_html .= '</form>';
    }

    public function hookDisplayFooter($params) {

        global $smarty;
        $czaterCode = Configuration::get($this->name . '_czaterCode');
        
        preg_match('/[0-9a-f]{40}/i', $czaterCode, $matches);
        $czaterId = $matches[0];

        $css_template = "";
        preg_match('/(css_template:)([\W]*)([0-9a-zA-Z]{8})/', $czaterCode, $code);
        if(isset($code[3])) $css_template = $code[3];
        
        $czaterAutoCompliteLogin = Configuration::get($this->name . '_czaterAutoCompliteLogin');
        $czaterAutoCompliteEmail = Configuration::get($this->name . '_czaterAutoCompliteEmail');
        
        if($czaterAutoCompliteLogin == 1){
            $smarty->assign('user', $this->context->customer->firstname." ".$this->context->customer->lastname);
        }
        else{
            $smarty->assign('user', "");
        }
        
        if($czaterAutoCompliteEmail == 1){
            $smarty->assign('email', $this->context->customer->email);
        }
        else{
            $smarty->assign('email', "");
        }

        $smarty->assign('czaterId', $czaterId);
        $smarty->assign('css_template',$css_template);
        
        return $this->display(__FILE__, 'czater2.tpl');
    }
    
    private function get_string_between($string, $start, $end){
        $string = " ".$string;
        $ini = strpos($string,$start);
        if ($ini == 0) return "";
        $ini += strlen($start);
        $len = strpos($string,$end,$ini) - $ini;
        return substr($string,$ini,$len);
    }

}
